#ifndef DELSTATION_H_
#define DELSTATION_H_
/**
 * @class eoCPTEO_V1DelMutation
 * @author Jacques Bibai
 * @brief definition d'un operateur de mutation : mutation permettant de supprimer
 * une gare.  
 */
template<class GenotypeT> 
class eoCPTEO_V1DelMutation: public eoMonOp<GenotypeT>{
public:
	/**
		 * Constructeur vide
		 */
  eoCPTEO_V1DelMutation()
  {
    
  }
	string className() const { return "eoCPTEO_V1DelMutation"; }

  /**
   * @fn bool operator()(GenotypeT &)
   * @brief Operateur decrivant la maniere d'effectuer une mutation par suppression d'une gare intermediaire. 
   * Ici on tire aleatoirement une gare et on la supprime.  
   * @param individu instance de la classe GenotypeT
   * @return bool : vrai si l'operation a reussi et faux sinon
   */ 
  bool operator()(GenotypeT & _genotype)
  {
	// cout << "**********************is modified del-------------------- \n";
     bool isModified=false;
     //cout << _genotype;
     std::vector<Gene> tmp;
	 tmp.resize(_genotype.getGenome().size());
    if(tmp.size()>1){ 
	    
	    for(size_t i=0;i<tmp.size();i++){
		   		tmp[i].getGene().resize(_genotype.get(i).size());
		   		 for(size_t j=0;j<tmp[i].size();j++){
		   		 	tmp[i].set(j,_genotype.get(i).get(j));
		   		 }
		   		 _genotype.get(i).getGene().clear();
		   	}
	        
	    
		    unsigned which,pos=0;
		     which =rng.random( _genotype.getBreakStation());//which=0; 
		   	//which =rng.random( _genotype.getBreakStation());
		   	if(which>=tmp.size())which=tmp.size()-1;
		   _genotype.getGenome().clear();
		   	_genotype.getGenome().resize(tmp.size()-1);
		   	for(size_t i=0;i<tmp.size();i++){
		   		if(i!=which){
		   			_genotype.set(pos,tmp[i]);
		   			pos++;
		   		}
		   		tmp[i].getGene().clear();
		   	}
		   isModified=true;	
		   tmp.clear();
    }
  // cout << _genotype;
  // cout << "**********************is modified del-------------------- \n";
   return  isModified;


}
};
#endif /*DELSTATION_H_*/
